#!/usr/bin/env python

from RecurrenceSupport import getRecurrence, ParseError

# Good recurrences.

s = "every single day of 2013"
print s
print "->", getRecurrence(s)

s = "every Tuesday of 2013"
print s
print "->", getRecurrence(s)

s = "every Wednesday of every March"
print s
print "->", getRecurrence(s)

s = "every single day of every other February from 2013-02"
print s
print "->", getRecurrence(s)

s = "every other day from 2013-02-01"
print s
print "->", getRecurrence(s)

s = "every single day of the second month of 2013"
print s
print "->", getRecurrence(s)

s = "every single day of the second month in 2013"
print s
print "->", getRecurrence(s)

s = "every single day of the second month of every year"
print s
print "->", getRecurrence(s)

s = "every other day from the first day of every other month from the third month of every year"
print s
print "->", getRecurrence(s)

s = "the second day of every other month from the first month of 2012"
print s
print "->", getRecurrence(s)

s = "the second day of every other month from January of 2012"
print s
print "->", getRecurrence(s)

s = "the second day of every other month from 2012-01"
print s
print "->", getRecurrence(s)

s = "the second hour in the second day in the second month of every year"
print s
print "->", getRecurrence(s)

s = "every day from the second day until the 10th day of every other month until the fifth month of every other year from 2010"
print s
print "->", getRecurrence(s)

s = "every day from the 10th day in the second month until the 10th day in the 10th month " \
    "of every third month from the first month of every year until 2011"
print s
print "->", getRecurrence(s)

s = "every day from the 10th day in February until the 10th day in October " \
    "of every third month from January of every year until 2011"
print s
print "->", getRecurrence(s)

# Bad recurrences.

print

# Incomplete specification.

s = "every single day of the second month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "the second day of every other month from the first month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every day from the second day until the 10th day of every other month until the fifth month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every day from the 10th day in the second month until the 10th day in the 10th month of every third month from the first month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every day from the 10th day in February until the 10th day in October of every third month from January"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

# Limits do not match recurrence.

s = "every single day of every other February from 2013"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every single day of every other February from 2013-02-01"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every day of every third month from the 10th day in the second month until the 10th day in the 10th month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

# No start or end points.

s = "every other day of every other month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every other day of every other month from the third month of every year"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "the second day of every other month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every day from the second day until the 10th day of every other month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

s = "every day from the 10th day in the second month until the 10th day in the 10th month of every third month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

# Syntax error: need to use "of" instead of "in".

s = "every single day in the second month"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

# Out of order: days do not contain months.

s = "every other month from the first month of every other day from the first day"
print s
try:
    print "->", getRecurrence(s)
except ParseError, exc:
    print exc

# vim: tabstop=4 expandtab shiftwidth=4
